// (C)opyright 2021-07-15 Dirk Holtwick, holtwick.it. All rights reserved.
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 * @returns
 */
export function getSourceLocation(level = 2, stripCwd = true) {
    var _a, _b, _c;
    let line;
    let stack = new Error().stack;
    if (typeof stack === "string") {
        line = (_c = (_b = (_a = stack === null || stack === void 0 ? void 0 : stack.split("\n")) === null || _a === void 0 ? void 0 : _a.map((rawLine) => { var _a; return (_a = rawLine.match(/^\s+at.*\((.*?)\)/)) === null || _a === void 0 ? void 0 : _a[1]; })) === null || _b === void 0 ? void 0 : _b.filter((v) => v != null)) === null || _c === void 0 ? void 0 : _c[level];
        if (line && stripCwd && line.startsWith(process.cwd())) {
            line = line.substr(process.cwd().length + 1);
        }
    }
    return line || "";
}
//# sourceMappingURL=log-util.js.map